<template>
  <v-container
    v-if="matchStore.match"
    color="white"
  >
    <v-row
      cols="12"
      align="start"
      justify="center"
    >
      <v-col>
        <v-sheet
          class="text-center"
        >        
          <trivia-match
            :match="matchStore.match" 
            @on-match-finished="onMatchFinished"
          />
        </v-sheet>
      </v-col>
    </v-row>
  </v-container>
  <v-container
    v-else
    color="white"
  >
    <v-row>
      <v-col
        v-if="waitingForOpponent"
        cols="12"
      >
        <v-sheet class="text-center">
          Waiting for Opponent...
        </v-sheet>
      </v-col>
      <v-col
        v-else
        cols="12"
      >
        <v-sheet class="text-center">
          &nbsp;
        </v-sheet>
      </v-col>
   
      <v-col
        class="text-center"
      >
        <v-btn
          v-if="userStore.user && !waitingForOpponent"
          prepend-icon="mdi-play"
          color="success"
          size="x-large"
          rounded="xl"
          elevated
          stacked
          @click="playGame"
        >
          Play
        </v-btn>
        <v-btn
          v-if="waitingForOpponent"
          prepend-icon="mdi-cancel"
          color="error"
          size="x-large"
          rounded="xl"
          elevated
          stacked
          @click="cancelGame"
        >
          Cancel
        </v-btn>
      </v-col>
    </v-row>
  </v-container>
</template>

<script setup>
import { ref } from "vue"
import { post, del } from "aws-amplify/api"
//
import { useUserStore } from "@/stores/userStore.js"
const userStore = useUserStore()
import { useMatchStore } from "@/stores/matchStore.js"
const matchStore = useMatchStore()
//
import TriviaMatch from "@/components/trivia/TriviaMatch.vue"

let waitingForOpponent = ref(false)
let matchId

const playGame = () => {
  waitingForOpponent.value = true
  createMatch()
}

const cancelGame = () => {
  waitingForOpponent.value = false
  deleteMatch()
}

const onMatchFinished = () => {
  waitingForOpponent.value = false
}

const createMatch = async () => {
  try {
    const restOperation = post({
      apiName: "fanfesttrivia",
      path: "/trivia/match",
    })

    const { body } = await restOperation.response
    const response = await body.json()
    matchId = response.matchId
    console.log("POST call succeeded")
    console.log(response)
  } catch (error) {
    console.error(error)
  }
}

const deleteMatch = async () => {
  // only delete match if i started it
  if(matchId) {
    try {
      const restOperation = del({
        apiName: "fanfesttrivia",
        path: `/trivia/match/${matchId}`,
      })

      matchId = undefined
      const { body } = await restOperation.response
      const response = await body.json()

      console.log("DELETE call succeeded")
      console.log(response)
    } catch (error) {
      console.error(error)
    }
  }
}

</script>